#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <windows.h>
#include <setupapi.h>
#include <devguid.h>
#include <ntddstor.h>
#include <winioctl.h>

int main(int argc, char **argv)
{
	int ifidx;
	HDEVINFO devset;
	SP_DEVICE_INTERFACE_DATA devif;
	SP_DEVICE_INTERFACE_DETAIL_DATA_A *devdetail;
	DWORD detsz;

	if((devset = SetupDiGetClassDevs(&GUID_DEVINTERFACE_DISK, 0, 0,
					DIGCF_PRESENT | DIGCF_DEVICEINTERFACE)) == INVALID_HANDLE_VALUE) {
		fprintf(stderr, "failed to enumerate devices\n");
		return 1;
	}

	ifidx = 0;
	for(;;) {
		memset(&devif, 0, sizeof devif);
		devif.cbSize = sizeof devif;
		if(!SetupDiEnumDeviceInterfaces(devset, 0, &GUID_DEVINTERFACE_DISK, ifidx, &devif)) {
			if(GetLastError() == ERROR_NO_MORE_ITEMS) break;
			ifidx++;
			continue;
		}

		SetupDiGetDeviceInterfaceDetail(devset, &devif, 0, 0, &detsz, 0);
		if(!(devdetail = malloc(detsz))) {
			fprintf(stderr, "failed to allocate device interface detail buffer (size: %lu)\n", (unsigned long)detsz);
			return 1;
		}
		devdetail->cbSize = sizeof *devdetail;
		SetupDiGetDeviceInterfaceDetail(devset, &devif, devdetail, detsz, 0, 0);
		printf("device path: %s\n", devdetail->DevicePath);
		free(devdetail);

		ifidx++;
	}
	printf("found %d devices\n", ifidx);
	return 0;
}
